gtkmm 4.10.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::FileLauncher Class Reference

A Gtk::FileLauncher object collects the arguments that are needed to open a uri with an application. More...

`#include <gtkmm/filelauncher.h>`

Inheritance diagram for Gtk::FileLauncher:
[legend]

## Public Member Functions
| FileLauncher (FileLauncher && src) noexcept
FileLauncher & | operator= (FileLauncher && src) noexcept
| ~FileLauncher () noexcept override
GtkFileLauncher * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkFileLauncher * | gobj () const
| Provides access to the underlying C GObject. More...
GtkFileLauncher * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gio::File > | get_file ()
| Gets the file that will be opened. More...
Glib::RefPtr< const Gio::File > | get_file () const
| Gets the file that will be opened. More...
void | set_file (const Glib::RefPtr< Gio::File > & file)
| Sets the file that will be opened. More...
void | launch (Window & parent, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| Launch an application to open the file. More...
void | launch (const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A launch() convenience overload. More...
bool | launch_finish (const Glib::RefPtr< Gio::AsyncResult > & result) const
| Finishes the launch() call and returns the result. More...
void | open_containing_folder (Window & parent, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| Launch a file manager to show the file in its parent directory. More...
void | open_containing_folder (const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A open_containing_folder() convenience overload. More...
bool | open_containing_folder_finish (const Glib::RefPtr< Gio::AsyncResult > & result) const
| Finishes the open_containing_folder() call and returns the result. More...
Glib::PropertyProxy< Glib::RefPtr< Gio::File > > | property_file ()
| The file to launch. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::File > > | property_file () const
| The file to launch. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< FileLauncher > | create (const Glib::RefPtr< Gio::File > & file={})

## Protected Member Functions
| FileLauncher (const Glib::RefPtr< Gio::File > & file)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::FileLauncher > | wrap (GtkFileLauncher * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Gtk::FileLauncher object collects the arguments that are needed to open a uri with an application.

Depending on system configuration, user preferences and available APIs, this may or may not show an app chooser dialog or launch the default application right away.

The operation is started with the launch() method. This API follows the GIO async pattern, and the result can be obtained by calling launch_finish().

To launch uris that don't represent files, use Gtk::UriLauncher.

Since gtkmm 4.10:

## Constructor & Destructor Documentation

## ◆ FileLauncher() [1/2]

Gtk::FileLauncher::FileLauncher | ( | FileLauncher && | src | ) |
| noexcept

## ◆ ~FileLauncher()

Gtk::FileLauncher::~FileLauncher | ( |  | ) |
| override noexcept

## ◆ FileLauncher() [2/2]

Gtk::FileLauncher::FileLauncher | ( | const Glib::RefPtr< Gio::File > & | file | ) |
| explicit protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<FileLauncher> Gtk::FileLauncher::create | ( | const Glib::RefPtr< Gio::File > & | file = `{}` | ) |
| static

## ◆ get_file() [1/2]

Glib::RefPtr<Gio::File> Gtk::FileLauncher::get_file | ( |  | ) |

Gets the file that will be opened.

Since gtkmm 4.10:

Returns
  The file.

## ◆ get_file() [2/2]

Glib::RefPtr<const Gio::File> Gtk::FileLauncher::get_file | ( |  | ) | const

Gets the file that will be opened.

Since gtkmm 4.10:

Returns
  The file.

## ◆ get_type()

static GType Gtk::FileLauncher::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkFileLauncher* Gtk::FileLauncher::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkFileLauncher* Gtk::FileLauncher::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkFileLauncher* Gtk::FileLauncher::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ launch() [1/2]

void Gtk::FileLauncher::launch | ( | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = `{}`
| ) |  | const

A launch() convenience overload.

## ◆ launch() [2/2]

void Gtk::FileLauncher::launch | ( | Window & | parent,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = `{}`
| ) |  | const

Launch an application to open the file.

This may present an app chooser dialog to the user.

The slot will be called when the operation is completed. It should call launch_finish() to obtain the result.

Since gtkmm 4.10:

Parameters

  parent | The parent `Gtk::Window`.
  cancellable | A `Cancellable` to cancel the operation.
  slot | A callback to call when the operation is complete.

## ◆ launch_finish()

bool Gtk::FileLauncher::launch_finish | ( | const Glib::RefPtr< Gio::AsyncResult > & | result | ) | const

Finishes the launch() call and returns the result.

Since gtkmm 4.10:

Parameters

  result | A `Gio::AsyncResult`.

Returns
  `true` if an application was launched, or `false` and error is set.

Exceptions

  Gtk::DialogError |
  Gio::Error |

## ◆ open_containing_folder() [1/2]

void Gtk::FileLauncher::open_containing_folder | ( | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = `{}`
| ) |  | const

A open_containing_folder() convenience overload.

## ◆ open_containing_folder() [2/2]

void Gtk::FileLauncher::open_containing_folder | ( | Window & | parent,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = `{}`
| ) |  | const

Launch a file manager to show the file in its parent directory.

This is only supported native files. It will fail if file is e.g. a http:// uri.

The slot will be called when the operation is completed. It should call open_containing_folder_finish() to obtain the result.

Since gtkmm 4.10:

Parameters

  parent | The parent `Gtk::Window`.
  cancellable | A `Cancellable` to cancel the operation.
  slot | A callback to call when the operation is complete.

## ◆ open_containing_folder_finish()

bool Gtk::FileLauncher::open_containing_folder_finish | ( | const Glib::RefPtr< Gio::AsyncResult > & | result | ) | const

Finishes the open_containing_folder() call and returns the result.

Since gtkmm 4.10:

Parameters

  result | A `Gio::AsyncResult`.

Returns
  `true` if an application was launched, or `false` and error is set.

Exceptions

  Gtk::DialogError |
  Gio::Error |

## ◆ operator=()

FileLauncher& Gtk::FileLauncher::operator= | ( | FileLauncher && | src | ) |
| noexcept

## ◆ property_file() [1/2]

Glib::PropertyProxy< Glib::RefPtr<Gio::File> > Gtk::FileLauncher::property_file | ( |  | ) |

The file to launch.

Since gtkmm 4.10:

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_file() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::File> > Gtk::FileLauncher::property_file | ( |  | ) | const

The file to launch.

Since gtkmm 4.10:

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_file()

void Gtk::FileLauncher::set_file | ( | const Glib::RefPtr< Gio::File > & | file | ) |

Sets the file that will be opened.

Since gtkmm 4.10:

Parameters

  file | A `Gio::File`.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::FileLauncher > wrap | ( | GtkFileLauncher * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.